package com.zhibao.crm.utils;

import com.zhibao.crm.erp.crm.entity.CrmInsurance;
import com.zhibao.crm.erp.crm.entity.CrmInsuranceType;
import java.awt.image.BufferedImage;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.math.BigDecimal;
import java.net.HttpURLConnection;
import java.net.URL;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.Base64;
import java.util.Date;
import java.util.List;
import javax.imageio.ImageIO;
import net.coobird.thumbnailator.Thumbnails;

public class FileUtil {

   public static void main(String[] args) throws IOException {
      Path pdfPath = Paths.get("D:\\eclipse\\eclipse\\workspace\\zhibao--scrm\\src\\main\\webapp\\upload\\docx\\投保书【及经纪人委托】.docx", new String[0]);
      byte[] pdfBytes = Files.readAllBytes(pdfPath);
      String base64Pdf = Base64.getEncoder().encodeToString(pdfBytes);
      System.out.println("base64," + base64Pdf);
   }

   public static File downLoadByUrl(String urlStr, String fileName, String savePath) throws IOException {
      URL url = new URL(urlStr);
      HttpURLConnection conn = (HttpURLConnection)url.openConnection();
      conn.setConnectTimeout(5000);
      conn.setRequestProperty("User-Agent", "Mozilla/4.0 (compatible; MSIE 5.0; Windows NT; DigExt)");
      InputStream inputStream = conn.getInputStream();
      byte[] getData = readInputStream(inputStream);
      File saveDir = new File(savePath);
      if(!saveDir.exists()) {
         saveDir.mkdir();
      }

      File file = new File(saveDir + File.separator + fileName);
      FileOutputStream fos = new FileOutputStream(file);
      fos.write(getData);
      if(fos != null) {
         fos.close();
      }

      if(inputStream != null) {
         inputStream.close();
      }

      System.out.println("info:" + url + " download success");
      return file;
   }

   public static byte[] readInputStream(InputStream inputStream) throws IOException {
      byte[] buffer = new byte[1024];
      boolean len = false;
      ByteArrayOutputStream bos = new ByteArrayOutputStream();

      int len1;
      while((len1 = inputStream.read(buffer)) != -1) {
         bos.write(buffer, 0, len1);
      }

      bos.close();
      return bos.toByteArray();
   }

   public static String commpressPicForScale(String srcPath, String desPath, long desFileSize, double accuracy) {
      try {
         File e = new File(srcPath);
         long srcFilesize = e.length();
         System.out.println("原图片:" + srcPath + ",大小:" + srcFilesize / 1024L + "kb");
         commpressPicCycle(desPath, desFileSize, accuracy);
         File desFile = new File(desPath);
         System.out.println("目标图片:" + desPath + ",大小" + desFile.length() / 1024L + "kb");
         System.out.println("图片压缩完成!");
      } catch (Exception var10) {
         var10.printStackTrace();
      }

      return desPath;
   }

   public static void commpressPicCycle(String desPath, long desFileSize, double accuracy) throws IOException {
      File imgFile = new File(desPath);
      long fileSize = imgFile.length();
      if(fileSize > desFileSize * 1024L) {
         System.out.println("解压" + fileSize);
         BufferedImage bim = ImageIO.read(imgFile);
         int imgWidth = bim.getWidth();
         int imgHeight = bim.getHeight();
         int desWidth = (new BigDecimal(imgWidth)).multiply(new BigDecimal(accuracy)).intValue();
         int desHeight = (new BigDecimal(imgHeight)).multiply(new BigDecimal(accuracy)).intValue();
         Thumbnails.of(new String[]{desPath}).size(desWidth, desHeight).outputQuality(accuracy).toFile(desPath);
         commpressPicCycle(desPath, desFileSize, accuracy);
      }
   }

   public static List getFileName(String brandName, String names, int m) {
      String path = "D:\\job\\sts\\git\\crm2_new\\src\\main\\webapp\\insurance\\" + brandName + "\\" + names + "";
      File f = new File(path);
      if(!f.exists()) {
         System.out.println(path + " not exists");
         return null;
      } else {
         ArrayList crmInsurances = new ArrayList();
         File[] fa = f.listFiles();
         CrmInsuranceType insuranceType = (CrmInsuranceType)CrmInsuranceType.dao.findFirst("select insurance_type_id from crm_crm_insurance_type where name=?", new Object[]{names});

         for(int i = 0; i < fa.length; ++i) {
            File fs = fa[i];
            if(fs.isDirectory()) {
               System.out.println("http://62.234.108.16:8004/insurance/" + brandName + "/" + fs.getName());
            } else {
               CrmInsurance crmInsurance = new CrmInsurance();
               crmInsurance.setName(fs.getName());
               ++m;
               crmInsurance.setCode("PICC" + m);
               crmInsurance.setBrandId(Integer.valueOf(614));
               crmInsurance.setType(insuranceType.getInsuranceTypeId());
               crmInsurance.setCreateTime(new Date());
               crmInsurance.setStatus("1");
               crmInsurance.setPath("http://fubangbrokers.com/insurance/" + brandName + "/" + names + "/" + fs.getName());
               crmInsurances.add(crmInsurance);
               System.out.println(crmInsurance);
            }
         }

         return crmInsurances;
      }
   }
}
